"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var import0 = require("./ng2-select");
var import1 = require("@angular/core/src/change_detection/change_detection_util");
var import2 = require("@angular/core/src/linker/view");
var import3 = require("@angular/core/src/linker/view_utils");
var import5 = require("@angular/core/src/metadata/view");
var import6 = require("@angular/core/src/linker/view_type");
var import7 = require("@angular/core/src/change_detection/constants");
var import8 = require("@angular/core/src/linker/component_factory");
var import9 = require("@angular/forms/src/directives/control_value_accessor");
var import10 = require("./style.scss.shim.ngstyle");
var import11 = require("ng2-material-dropdown/dist/src/modules/components/menu-item/ng2-menu-item");
var import12 = require("../node_modules/ng2-material-dropdown/dist/src/modules/components/menu-item/ng2-menu-item.ngfactory");
var import13 = require("@angular/core/src/linker/view_container");
var import14 = require("@angular/core/src/linker/element_ref");
var import15 = require("@angular/core/src/linker/query_list");
var import16 = require("ng2-material-dropdown/dist/src/modules/components/dropdown/ng2-dropdown");
var import17 = require("ng2-material-dropdown/dist/src/modules/services/dropdown-state.service");
var import18 = require("../node_modules/ng2-material-dropdown/dist/src/modules/components/dropdown/ng2-dropdown.ngfactory");
var import19 = require("ng2-material-dropdown/dist/src/modules/components/button/ng2-dropdown-button");
var import20 = require("../node_modules/ng2-material-dropdown/dist/src/modules/components/button/ng2-dropdown-button.ngfactory");
var import21 = require("ng2-material-dropdown/dist/src/modules/components/menu/ng2-dropdown-menu");
var import22 = require("../node_modules/ng2-material-dropdown/dist/src/modules/components/menu/ng2-dropdown-menu.ngfactory");
var import23 = require("../node_modules/@angular/common/src/directives/ng_for.ngfactory");
var import24 = require("@angular/core/src/linker/template_ref");
var import25 = require("@angular/core/src/change_detection/differs/iterable_differs");
var import26 = require("@angular/common/src/directives/ng_for");
var Wrapper_Ng2Select = (function () {
    function Wrapper_Ng2Select() {
        this._changed = false;
        this.context = new import0.Ng2Select();
        this._expr_0 = import1.UNINITIALIZED;
        this._expr_1 = import1.UNINITIALIZED;
        this._expr_2 = import1.UNINITIALIZED;
        this._expr_3 = import1.UNINITIALIZED;
        this._expr_4 = import1.UNINITIALIZED;
        this._expr_5 = import1.UNINITIALIZED;
    }
    Wrapper_Ng2Select.prototype.ngOnDetach = function (view, componentView, el) {
    };
    Wrapper_Ng2Select.prototype.ngOnDestroy = function () {
        (this.subscription0 && this.subscription0.unsubscribe());
    };
    Wrapper_Ng2Select.prototype.check_placeholder = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_0, currValue))) {
            this._changed = true;
            this.context.placeholder = currValue;
            this._expr_0 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.check_options = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_1, currValue))) {
            this._changed = true;
            this.context.options = currValue;
            this._expr_1 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.check_displayBy = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_2, currValue))) {
            this._changed = true;
            this.context.displayBy = currValue;
            this._expr_2 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.check_identifyBy = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_3, currValue))) {
            this._changed = true;
            this.context.identifyBy = currValue;
            this._expr_3 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.check_selectedDisplayBy = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_4, currValue))) {
            this._changed = true;
            this.context.selectedDisplayBy = currValue;
            this._expr_4 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.check_multiple = function (currValue, throwOnChange, forceUpdate) {
        if ((forceUpdate || import3.checkBinding(throwOnChange, this._expr_5, currValue))) {
            this._changed = true;
            this.context.multiple = currValue;
            this._expr_5 = currValue;
        }
    };
    Wrapper_Ng2Select.prototype.ngDoCheck = function (view, el, throwOnChange) {
        var changed = this._changed;
        this._changed = false;
        if (!throwOnChange) {
            if ((view.numberOfChecks === 0)) {
                this.context.ngOnInit();
            }
        }
        return changed;
    };
    Wrapper_Ng2Select.prototype.checkHost = function (view, componentView, el, throwOnChange) {
    };
    Wrapper_Ng2Select.prototype.handleEvent = function (eventName, $event) {
        var result = true;
        return result;
    };
    Wrapper_Ng2Select.prototype.subscribe = function (view, _eventHandler, emit0) {
        this._eventHandler = _eventHandler;
        if (emit0) {
            (this.subscription0 = this.context.onChange.subscribe(_eventHandler.bind(view, 'onChange')));
        }
    };
    return Wrapper_Ng2Select;
}());
exports.Wrapper_Ng2Select = Wrapper_Ng2Select;
var renderType_Ng2Select_Host = import3.createRenderComponentType('', 0, import5.ViewEncapsulation.None, [], {});
var View_Ng2Select_Host0 = (function (_super) {
    __extends(View_Ng2Select_Host0, _super);
    function View_Ng2Select_Host0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_Ng2Select_Host0, renderType_Ng2Select_Host, import6.ViewType.HOST, viewUtils, parentView, parentIndex, parentElement, import7.ChangeDetectorStatus.CheckAlways) || this;
    }
    Object.defineProperty(View_Ng2Select_Host0.prototype, "_NG_VALUE_ACCESSOR_0_4", {
        get: function () {
            if ((this.__NG_VALUE_ACCESSOR_0_4 == null)) {
                (this.__NG_VALUE_ACCESSOR_0_4 = [this._Ng2Select_0_3.context]);
            }
            return this.__NG_VALUE_ACCESSOR_0_4;
        },
        enumerable: true,
        configurable: true
    });
    View_Ng2Select_Host0.prototype.createInternal = function (rootSelector) {
        this._el_0 = import3.selectOrCreateRenderHostElement(this.renderer, 'ng2-select', import3.EMPTY_INLINE_ARRAY, rootSelector, null);
        this.compView_0 = new View_Ng2Select0(this.viewUtils, this, 0, this._el_0);
        this._Ng2Select_0_3 = new Wrapper_Ng2Select();
        this.compView_0.create(this._Ng2Select_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [this._el_0]), null);
        return new import8.ComponentRef_(0, this, this._el_0, this._Ng2Select_0_3.context);
    };
    View_Ng2Select_Host0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import0.Ng2Select) && (0 === requestNodeIndex))) {
            return this._Ng2Select_0_3.context;
        }
        if (((token === import9.NG_VALUE_ACCESSOR) && (0 === requestNodeIndex))) {
            return this._NG_VALUE_ACCESSOR_0_4;
        }
        return notFoundResult;
    };
    View_Ng2Select_Host0.prototype.detectChangesInternal = function (throwOnChange) {
        this._Ng2Select_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_Ng2Select_Host0.prototype.destroyInternal = function () {
        this.compView_0.destroy();
        this._Ng2Select_0_3.ngOnDestroy();
    };
    View_Ng2Select_Host0.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    return View_Ng2Select_Host0;
}(import2.AppView));
exports.Ng2SelectNgFactory = new import8.ComponentFactory('ng2-select', View_Ng2Select_Host0, import0.Ng2Select);
var styles_Ng2Select = [import10.styles];
var View_Ng2Select1 = (function (_super) {
    __extends(View_Ng2Select1, _super);
    function View_Ng2Select1(viewUtils, parentView, parentIndex, parentElement, declaredViewContainer) {
        var _this = _super.call(this, View_Ng2Select1, renderType_Ng2Select, import6.ViewType.EMBEDDED, viewUtils, parentView, parentIndex, parentElement, import7.ChangeDetectorStatus.CheckAlways, declaredViewContainer) || this;
        _this._expr_4 = import1.UNINITIALIZED;
        _this._expr_5 = import1.UNINITIALIZED;
        return _this;
    }
    View_Ng2Select1.prototype.createInternal = function (rootSelector) {
        this._el_0 = import3.createRenderElement(this.renderer, null, 'ng2-menu-item', import3.EMPTY_INLINE_ARRAY, null);
        this.compView_0 = new import12.View_Ng2MenuItem0(this.viewUtils, this, 0, this._el_0);
        this._Ng2MenuItem_0_3 = new import12.Wrapper_Ng2MenuItem(this.parentView._DropdownStateService_0_3, new import14.ElementRef(this._el_0), this.renderer);
        this._text_1 = this.renderer.createText(null, '', null);
        this.compView_0.create(this._Ng2MenuItem_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [
            this._el_0,
            this._text_1
        ]), null);
        return null;
    };
    View_Ng2Select1.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import11.Ng2MenuItem) && ((0 <= requestNodeIndex) && (requestNodeIndex <= 1)))) {
            return this._Ng2MenuItem_0_3.context;
        }
        return notFoundResult;
    };
    View_Ng2Select1.prototype.detectChangesInternal = function (throwOnChange) {
        var currVal_0_0_0 = this.parentView.context.multiple;
        this._Ng2MenuItem_0_3.check_preventClose(currVal_0_0_0, throwOnChange, false);
        var currVal_0_0_1 = this.context.$implicit;
        this._Ng2MenuItem_0_3.check_value(currVal_0_0_1, throwOnChange, false);
        this._Ng2MenuItem_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        var currVal_4 = this.parentView.context.isSelected(this.context.$implicit);
        if (import3.checkBinding(throwOnChange, this._expr_4, currVal_4)) {
            this.renderer.setElementClass(this._el_0, 'selected', currVal_4);
            this._expr_4 = currVal_4;
        }
        var currVal_5 = import3.inlineInterpolate(1, '\n            ', this.parentView.context.displayValue(this.context.$implicit), '\n        ');
        if (import3.checkBinding(throwOnChange, this._expr_5, currVal_5)) {
            this.renderer.setText(this._text_1, currVal_5);
            this._expr_5 = currVal_5;
        }
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_Ng2Select1.prototype.dirtyParentQueriesInternal = function () {
        this.parentView._query_Ng2MenuItem_5_0.setDirty();
    };
    View_Ng2Select1.prototype.destroyInternal = function () {
        this.compView_0.destroy();
    };
    View_Ng2Select1.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    View_Ng2Select1.prototype.visitProjectableNodesInternal = function (nodeIndex, ngContentIndex, cb, ctx) {
        if (((nodeIndex == 0) && (ngContentIndex == 0))) {
            cb(this._text_1, ctx);
        }
    };
    return View_Ng2Select1;
}(import2.AppView));
var renderType_Ng2Select = import3.createRenderComponentType('', 0, import5.ViewEncapsulation.Emulated, styles_Ng2Select, {});
var View_Ng2Select0 = (function (_super) {
    __extends(View_Ng2Select0, _super);
    function View_Ng2Select0(viewUtils, parentView, parentIndex, parentElement) {
        var _this = _super.call(this, View_Ng2Select0, renderType_Ng2Select, import6.ViewType.COMPONENT, viewUtils, parentView, parentIndex, parentElement, import7.ChangeDetectorStatus.CheckAlways) || this;
        _this._expr_25 = import1.UNINITIALIZED;
        return _this;
    }
    View_Ng2Select0.prototype.createInternal = function (rootSelector) {
        var parentRenderNode = this.renderer.createViewRoot(this.parentElement);
        this._viewQuery_Ng2Dropdown_0 = new import15.QueryList();
        this._el_0 = import3.createRenderElement(this.renderer, parentRenderNode, 'ng2-dropdown', import3.EMPTY_INLINE_ARRAY, null);
        this.compView_0 = new import18.View_Ng2Dropdown0(this.viewUtils, this, 0, this._el_0);
        this._DropdownStateService_0_3 = new import17.DropdownStateService();
        this._Ng2Dropdown_0_4 = new import18.Wrapper_Ng2Dropdown(this._DropdownStateService_0_3);
        this._query_Ng2DropdownButton_0_0 = new import15.QueryList();
        this._query_Ng2DropdownMenu_0_1 = new import15.QueryList();
        this._text_1 = this.renderer.createText(null, '\n    ', null);
        this._el_2 = import3.createRenderElement(this.renderer, null, 'ng2-dropdown-button', import3.EMPTY_INLINE_ARRAY, null);
        this.compView_2 = new import20.View_Ng2DropdownButton0(this.viewUtils, this, 2, this._el_2);
        this._Ng2DropdownButton_2_3 = new import20.Wrapper_Ng2DropdownButton(new import14.ElementRef(this._el_2));
        this._text_3 = this.renderer.createText(null, '', null);
        this.compView_2.create(this._Ng2DropdownButton_2_3.context);
        this._text_4 = this.renderer.createText(null, '\n    ', null);
        this._el_5 = import3.createRenderElement(this.renderer, null, 'ng2-dropdown-menu', import3.EMPTY_INLINE_ARRAY, null);
        this.compView_5 = new import22.View_Ng2DropdownMenu0(this.viewUtils, this, 5, this._el_5);
        this._Ng2DropdownMenu_5_3 = new import22.Wrapper_Ng2DropdownMenu(this._DropdownStateService_0_3, new import14.ElementRef(this._el_5), this.renderer);
        this._query_Ng2MenuItem_5_0 = new import15.QueryList();
        this._text_6 = this.renderer.createText(null, '\n        ', null);
        this._anchor_7 = this.renderer.createTemplateAnchor(null, null);
        this._vc_7 = new import13.ViewContainer(7, 5, this, this._anchor_7);
        this._TemplateRef_7_5 = new import24.TemplateRef_(this, 7, this._anchor_7);
        this._NgFor_7_6 = new import23.Wrapper_NgFor(this._vc_7.vcRef, this._TemplateRef_7_5, this.parentView.injectorGet(import25.IterableDiffers, this.parentIndex), this.ref);
        this._text_8 = this.renderer.createText(null, '\n    ', null);
        this.compView_5.create(this._Ng2DropdownMenu_5_3.context);
        this._text_9 = this.renderer.createText(null, '\n', null);
        this.compView_0.create(this._Ng2Dropdown_0_4.context);
        this._text_10 = this.renderer.createText(parentRenderNode, '\n', null);
        var disposable_0 = import3.subscribeToRenderElement(this, this._el_0, new import3.InlineArray2(2, 'scroll', 'window'), this.eventHandler(this.handleEvent_0));
        this._query_Ng2DropdownButton_0_0.reset([this._Ng2DropdownButton_2_3.context]);
        this._Ng2Dropdown_0_4.context.button = this._query_Ng2DropdownButton_0_0.first;
        this._query_Ng2DropdownMenu_0_1.reset([this._Ng2DropdownMenu_5_3.context]);
        this._Ng2Dropdown_0_4.context.menu = this._query_Ng2DropdownMenu_0_1.first;
        this._viewQuery_Ng2Dropdown_0.reset([this._Ng2Dropdown_0_4.context]);
        this.context.dropdown = this._viewQuery_Ng2Dropdown_0.first;
        this.init(null, (this.renderer.directRenderer ? null : [
            this._el_0,
            this._text_1,
            this._el_2,
            this._text_3,
            this._text_4,
            this._el_5,
            this._text_6,
            this._anchor_7,
            this._text_8,
            this._text_9,
            this._text_10
        ]), [disposable_0]);
        return null;
    };
    View_Ng2Select0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import19.Ng2DropdownButton) && ((2 <= requestNodeIndex) && (requestNodeIndex <= 3)))) {
            return this._Ng2DropdownButton_2_3.context;
        }
        if (((token === import24.TemplateRef) && (7 === requestNodeIndex))) {
            return this._TemplateRef_7_5;
        }
        if (((token === import26.NgFor) && (7 === requestNodeIndex))) {
            return this._NgFor_7_6.context;
        }
        if (((token === import21.Ng2DropdownMenu) && ((5 <= requestNodeIndex) && (requestNodeIndex <= 8)))) {
            return this._Ng2DropdownMenu_5_3.context;
        }
        if (((token === import17.DropdownStateService) && ((0 <= requestNodeIndex) && (requestNodeIndex <= 9)))) {
            return this._DropdownStateService_0_3;
        }
        if (((token === import16.Ng2Dropdown) && ((0 <= requestNodeIndex) && (requestNodeIndex <= 9)))) {
            return this._Ng2Dropdown_0_4.context;
        }
        return notFoundResult;
    };
    View_Ng2Select0.prototype.detectChangesInternal = function (throwOnChange) {
        this._Ng2Dropdown_0_4.ngDoCheck(this, this._el_0, throwOnChange);
        this._Ng2DropdownButton_2_3.ngDoCheck(this, this._el_2, throwOnChange);
        var currVal_5_0_0 = false;
        this._Ng2DropdownMenu_5_3.check_focusFirstElement(currVal_5_0_0, throwOnChange, false);
        this._Ng2DropdownMenu_5_3.ngDoCheck(this, this._el_5, throwOnChange);
        var currVal_7_0_0 = this.context.options;
        this._NgFor_7_6.check_ngForOf(currVal_7_0_0, throwOnChange, false);
        var currVal_7_0_1 = this.context.identify;
        this._NgFor_7_6.check_ngForTrackBy(currVal_7_0_1, throwOnChange, false);
        this._NgFor_7_6.ngDoCheck(this, this._anchor_7, throwOnChange);
        this._vc_7.detectChangesInNestedViews(throwOnChange);
        if (!throwOnChange) {
            if (this._query_Ng2MenuItem_5_0.dirty) {
                this._query_Ng2MenuItem_5_0.reset([this._vc_7.mapNestedViews(View_Ng2Select1, function (nestedView) {
                        return [nestedView._Ng2MenuItem_0_3.context];
                    })]);
                this._Ng2DropdownMenu_5_3.context.items = this._query_Ng2MenuItem_5_0;
                this._query_Ng2MenuItem_5_0.notifyOnChanges();
            }
        }
        var currVal_25 = import3.inlineInterpolate(1, '\n        ', this.context.placeholderDisplay, '\n    ');
        if (import3.checkBinding(throwOnChange, this._expr_25, currVal_25)) {
            this.renderer.setText(this._text_3, currVal_25);
            this._expr_25 = currVal_25;
        }
        this.compView_0.internalDetectChanges(throwOnChange);
        this.compView_2.internalDetectChanges(throwOnChange);
        this.compView_5.internalDetectChanges(throwOnChange);
    };
    View_Ng2Select0.prototype.destroyInternal = function () {
        this._vc_7.destroyNestedViews();
        this.compView_0.destroy();
        this.compView_2.destroy();
        this.compView_5.destroy();
        this._Ng2DropdownButton_2_3.ngOnDestroy();
        this._Ng2DropdownMenu_5_3.ngOnDestroy();
        this._Ng2Dropdown_0_4.ngOnDestroy();
    };
    View_Ng2Select0.prototype.visitProjectableNodesInternal = function (nodeIndex, ngContentIndex, cb, ctx) {
        if (((nodeIndex == 0) && (ngContentIndex == 0))) {
            cb(this._el_2, ctx);
        }
        if (((nodeIndex == 0) && (ngContentIndex == 1))) {
            cb(this._el_5, ctx);
        }
        if (((nodeIndex == 2) && (ngContentIndex == 0))) {
            cb(this._text_3, ctx);
        }
        if (((nodeIndex == 5) && (ngContentIndex == 0))) {
            cb(this._text_6, ctx);
            cb(this._vc_7.nativeElement, ctx);
            this._vc_7.visitNestedViewRootNodes(cb, ctx);
            cb(this._text_8, ctx);
        }
    };
    View_Ng2Select0.prototype.createEmbeddedViewInternal = function (nodeIndex) {
        if ((nodeIndex == 7)) {
            return new View_Ng2Select1(this.viewUtils, this, 7, this._anchor_7, this._vc_7);
        }
        return null;
    };
    View_Ng2Select0.prototype.handleEvent_0 = function (eventName, $event) {
        this.compView_0.markPathToRootAsCheckOnce();
        var result = true;
        result = (this._Ng2Dropdown_0_4.handleEvent(eventName, $event) && result);
        return result;
    };
    return View_Ng2Select0;
}(import2.AppView));
exports.View_Ng2Select0 = View_Ng2Select0;
//# sourceMappingURL=ng2-select.ngfactory.js.map