"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var import0 = require("@angular/core/src/linker/ng_module_factory");
var import1 = require("./testing-helpers");
var import2 = require("@angular/common/src/common_module");
var import3 = require("@angular/forms/src/directives");
var import4 = require("@angular/forms/src/form_providers");
var import5 = require("ng2-material-dropdown/dist/src/modules/ng2-dropdown.module");
var import6 = require("./ng2-select.module");
var import7 = require("@angular/common/src/localization");
var import8 = require("@angular/forms/src/directives/radio_control_value_accessor");
var import9 = require("@angular/forms/src/form_builder");
var import11 = require("@angular/core/src/i18n/tokens");
var import12 = require("@angular/core/src/linker/view");
var import14 = require("@angular/core/src/linker/view_utils");
var import15 = require("@angular/core/src/metadata/view");
var import16 = require("@angular/core/src/linker/view_type");
var import17 = require("@angular/core/src/change_detection/constants");
var import18 = require("@angular/core/src/linker/component_factory");
var import19 = require("./ng2-select");
var import20 = require("./ng2-select.ngfactory");
var import21 = require("../node_modules/@angular/forms/src/directives/ng_model.ngfactory");
var import22 = require("../node_modules/@angular/forms/src/directives/ng_control_status.ngfactory");
var import23 = require("@angular/forms/src/directives/control_value_accessor");
var import24 = require("@angular/forms/src/directives/ng_model");
var import25 = require("@angular/forms/src/directives/ng_control");
var import26 = require("@angular/forms/src/directives/ng_control_status");
var TestModuleInjector = (function (_super) {
    __extends(TestModuleInjector, _super);
    function TestModuleInjector(parent) {
        return _super.call(this, parent, [], []) || this;
    }
    Object.defineProperty(TestModuleInjector.prototype, "_NgLocalization_7", {
        get: function () {
            if ((this.__NgLocalization_7 == null)) {
                (this.__NgLocalization_7 = new import7.NgLocaleLocalization(this.parent.get(import11.LOCALE_ID)));
            }
            return this.__NgLocalization_7;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TestModuleInjector.prototype, "_RadioControlRegistry_8", {
        get: function () {
            if ((this.__RadioControlRegistry_8 == null)) {
                (this.__RadioControlRegistry_8 = new import8.RadioControlRegistry());
            }
            return this.__RadioControlRegistry_8;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TestModuleInjector.prototype, "_FormBuilder_9", {
        get: function () {
            if ((this.__FormBuilder_9 == null)) {
                (this.__FormBuilder_9 = new import9.FormBuilder());
            }
            return this.__FormBuilder_9;
        },
        enumerable: true,
        configurable: true
    });
    TestModuleInjector.prototype.createInternal = function () {
        this._CommonModule_0 = new import2.CommonModule();
        this._InternalFormsSharedModule_1 = new import3.InternalFormsSharedModule();
        this._FormsModule_2 = new import4.FormsModule();
        this._ReactiveFormsModule_3 = new import4.ReactiveFormsModule();
        this._Ng2DropdownModule_4 = new import5.Ng2DropdownModule();
        this._Ng2SelectModule_5 = new import6.Ng2SelectModule();
        this._TestModule_6 = new import1.TestModule();
        return this._TestModule_6;
    };
    TestModuleInjector.prototype.getInternal = function (token, notFoundResult) {
        if ((token === import2.CommonModule)) {
            return this._CommonModule_0;
        }
        if ((token === import3.InternalFormsSharedModule)) {
            return this._InternalFormsSharedModule_1;
        }
        if ((token === import4.FormsModule)) {
            return this._FormsModule_2;
        }
        if ((token === import4.ReactiveFormsModule)) {
            return this._ReactiveFormsModule_3;
        }
        if ((token === import5.Ng2DropdownModule)) {
            return this._Ng2DropdownModule_4;
        }
        if ((token === import6.Ng2SelectModule)) {
            return this._Ng2SelectModule_5;
        }
        if ((token === import1.TestModule)) {
            return this._TestModule_6;
        }
        if ((token === import7.NgLocalization)) {
            return this._NgLocalization_7;
        }
        if ((token === import8.RadioControlRegistry)) {
            return this._RadioControlRegistry_8;
        }
        if ((token === import9.FormBuilder)) {
            return this._FormBuilder_9;
        }
        return notFoundResult;
    };
    TestModuleInjector.prototype.destroyInternal = function () {
    };
    return TestModuleInjector;
}(import0.NgModuleInjector));
exports.TestModuleNgFactory = new import0.NgModuleFactory(TestModuleInjector, import1.TestModule);
var Wrapper_SelectWithObject = (function () {
    function Wrapper_SelectWithObject() {
        this._changed = false;
        this.context = new import1.SelectWithObject();
    }
    Wrapper_SelectWithObject.prototype.ngOnDetach = function (view, componentView, el) {
    };
    Wrapper_SelectWithObject.prototype.ngOnDestroy = function () {
    };
    Wrapper_SelectWithObject.prototype.ngDoCheck = function (view, el, throwOnChange) {
        var changed = this._changed;
        this._changed = false;
        return changed;
    };
    Wrapper_SelectWithObject.prototype.checkHost = function (view, componentView, el, throwOnChange) {
    };
    Wrapper_SelectWithObject.prototype.handleEvent = function (eventName, $event) {
        var result = true;
        return result;
    };
    Wrapper_SelectWithObject.prototype.subscribe = function (view, _eventHandler) {
        this._eventHandler = _eventHandler;
    };
    return Wrapper_SelectWithObject;
}());
exports.Wrapper_SelectWithObject = Wrapper_SelectWithObject;
var Wrapper_BasicSelectWithArray = (function () {
    function Wrapper_BasicSelectWithArray() {
        this._changed = false;
        this.context = new import1.BasicSelectWithArray();
    }
    Wrapper_BasicSelectWithArray.prototype.ngOnDetach = function (view, componentView, el) {
    };
    Wrapper_BasicSelectWithArray.prototype.ngOnDestroy = function () {
    };
    Wrapper_BasicSelectWithArray.prototype.ngDoCheck = function (view, el, throwOnChange) {
        var changed = this._changed;
        this._changed = false;
        return changed;
    };
    Wrapper_BasicSelectWithArray.prototype.checkHost = function (view, componentView, el, throwOnChange) {
    };
    Wrapper_BasicSelectWithArray.prototype.handleEvent = function (eventName, $event) {
        var result = true;
        return result;
    };
    Wrapper_BasicSelectWithArray.prototype.subscribe = function (view, _eventHandler) {
        this._eventHandler = _eventHandler;
    };
    return Wrapper_BasicSelectWithArray;
}());
exports.Wrapper_BasicSelectWithArray = Wrapper_BasicSelectWithArray;
var Wrapper_SelectWithIdentifyBy = (function () {
    function Wrapper_SelectWithIdentifyBy() {
        this._changed = false;
        this.context = new import1.SelectWithIdentifyBy();
    }
    Wrapper_SelectWithIdentifyBy.prototype.ngOnDetach = function (view, componentView, el) {
    };
    Wrapper_SelectWithIdentifyBy.prototype.ngOnDestroy = function () {
    };
    Wrapper_SelectWithIdentifyBy.prototype.ngDoCheck = function (view, el, throwOnChange) {
        var changed = this._changed;
        this._changed = false;
        return changed;
    };
    Wrapper_SelectWithIdentifyBy.prototype.checkHost = function (view, componentView, el, throwOnChange) {
    };
    Wrapper_SelectWithIdentifyBy.prototype.handleEvent = function (eventName, $event) {
        var result = true;
        return result;
    };
    Wrapper_SelectWithIdentifyBy.prototype.subscribe = function (view, _eventHandler) {
        this._eventHandler = _eventHandler;
    };
    return Wrapper_SelectWithIdentifyBy;
}());
exports.Wrapper_SelectWithIdentifyBy = Wrapper_SelectWithIdentifyBy;
var Wrapper_SelectWithMultipleSelection = (function () {
    function Wrapper_SelectWithMultipleSelection() {
        this._changed = false;
        this.context = new import1.SelectWithMultipleSelection();
    }
    Wrapper_SelectWithMultipleSelection.prototype.ngOnDetach = function (view, componentView, el) {
    };
    Wrapper_SelectWithMultipleSelection.prototype.ngOnDestroy = function () {
    };
    Wrapper_SelectWithMultipleSelection.prototype.ngDoCheck = function (view, el, throwOnChange) {
        var changed = this._changed;
        this._changed = false;
        return changed;
    };
    Wrapper_SelectWithMultipleSelection.prototype.checkHost = function (view, componentView, el, throwOnChange) {
    };
    Wrapper_SelectWithMultipleSelection.prototype.handleEvent = function (eventName, $event) {
        var result = true;
        return result;
    };
    Wrapper_SelectWithMultipleSelection.prototype.subscribe = function (view, _eventHandler) {
        this._eventHandler = _eventHandler;
    };
    return Wrapper_SelectWithMultipleSelection;
}());
exports.Wrapper_SelectWithMultipleSelection = Wrapper_SelectWithMultipleSelection;
var renderType_SelectWithObject_Host = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, [], {});
var View_SelectWithObject_Host0 = (function (_super) {
    __extends(View_SelectWithObject_Host0, _super);
    function View_SelectWithObject_Host0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithObject_Host0, renderType_SelectWithObject_Host, import16.ViewType.HOST, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithObject_Host0.prototype.createInternal = function (rootSelector) {
        this._el_0 = import14.selectOrCreateRenderHostElement(this.renderer, 'app', import14.EMPTY_INLINE_ARRAY, rootSelector, null);
        this.compView_0 = new View_SelectWithObject0(this.viewUtils, this, 0, this._el_0);
        this._SelectWithObject_0_3 = new Wrapper_SelectWithObject();
        this.compView_0.create(this._SelectWithObject_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [this._el_0]), null);
        return new import18.ComponentRef_(0, this, this._el_0, this._SelectWithObject_0_3.context);
    };
    View_SelectWithObject_Host0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import1.SelectWithObject) && (0 === requestNodeIndex))) {
            return this._SelectWithObject_0_3.context;
        }
        return notFoundResult;
    };
    View_SelectWithObject_Host0.prototype.detectChangesInternal = function (throwOnChange) {
        this._SelectWithObject_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_SelectWithObject_Host0.prototype.destroyInternal = function () {
        this.compView_0.destroy();
    };
    View_SelectWithObject_Host0.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    return View_SelectWithObject_Host0;
}(import12.AppView));
exports.SelectWithObjectNgFactory = new import18.ComponentFactory('app', View_SelectWithObject_Host0, import1.SelectWithObject);
var styles_SelectWithObject = [];
var renderType_SelectWithObject = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, styles_SelectWithObject, {});
var View_SelectWithObject0 = (function (_super) {
    __extends(View_SelectWithObject0, _super);
    function View_SelectWithObject0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithObject0, renderType_SelectWithObject, import16.ViewType.COMPONENT, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithObject0.prototype.createInternal = function (rootSelector) {
        var parentRenderNode = this.renderer.createViewRoot(this.parentElement);
        this._text_0 = this.renderer.createText(parentRenderNode, '\n        ', null);
        this._el_1 = import14.createRenderElement(this.renderer, parentRenderNode, 'ng2-select', import14.EMPTY_INLINE_ARRAY, null);
        this.compView_1 = new import20.View_Ng2Select0(this.viewUtils, this, 1, this._el_1);
        this._Ng2Select_1_3 = new import20.Wrapper_Ng2Select();
        this._NG_VALUE_ACCESSOR_1_4 = [this._Ng2Select_1_3.context];
        this._NgModel_1_5 = new import21.Wrapper_NgModel(null, null, null, this._NG_VALUE_ACCESSOR_1_4);
        this._NgControl_1_6 = this._NgModel_1_5.context;
        this._NgControlStatus_1_7 = new import22.Wrapper_NgControlStatus(this._NgControl_1_6);
        this._text_2 = this.renderer.createText(null, '\n        ', null);
        this.compView_1.create(this._Ng2Select_1_3.context);
        this._text_3 = this.renderer.createText(parentRenderNode, '\n    ', null);
        var disposable_0 = import14.subscribeToRenderElement(this, this._el_1, new import14.InlineArray2(2, 'ngModelChange', null), this.eventHandler(this.handleEvent_1));
        this._NgModel_1_5.subscribe(this, this.eventHandler(this.handleEvent_1), true);
        this.init(null, (this.renderer.directRenderer ? null : [
            this._text_0,
            this._el_1,
            this._text_2,
            this._text_3
        ]), [disposable_0]);
        return null;
    };
    View_SelectWithObject0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import19.Ng2Select) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._Ng2Select_1_3.context;
        }
        if (((token === import23.NG_VALUE_ACCESSOR) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NG_VALUE_ACCESSOR_1_4;
        }
        if (((token === import24.NgModel) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgModel_1_5.context;
        }
        if (((token === import25.NgControl) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControl_1_6;
        }
        if (((token === import26.NgControlStatus) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControlStatus_1_7.context;
        }
        return notFoundResult;
    };
    View_SelectWithObject0.prototype.detectChangesInternal = function (throwOnChange) {
        var currVal_1_0_0 = 'Please choose Language';
        this._Ng2Select_1_3.check_placeholder(currVal_1_0_0, throwOnChange, false);
        var currVal_1_0_1 = this.context.options;
        this._Ng2Select_1_3.check_options(currVal_1_0_1, throwOnChange, false);
        var currVal_1_0_2 = 'value';
        this._Ng2Select_1_3.check_displayBy(currVal_1_0_2, throwOnChange, false);
        this._Ng2Select_1_3.ngDoCheck(this, this._el_1, throwOnChange);
        var currVal_1_1_0 = this.context.language;
        this._NgModel_1_5.check_model(currVal_1_1_0, throwOnChange, false);
        this._NgModel_1_5.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.checkHost(this, this.compView_1, this._el_1, throwOnChange);
        this.compView_1.internalDetectChanges(throwOnChange);
    };
    View_SelectWithObject0.prototype.destroyInternal = function () {
        this.compView_1.destroy();
        this._Ng2Select_1_3.ngOnDestroy();
        this._NgModel_1_5.ngOnDestroy();
    };
    View_SelectWithObject0.prototype.handleEvent_1 = function (eventName, $event) {
        this.markPathToRootAsCheckOnce();
        var result = true;
        if ((eventName == 'ngModelChange')) {
            var pd_sub_0 = ((this.context.language = $event) !== false);
            result = (pd_sub_0 && result);
        }
        return result;
    };
    return View_SelectWithObject0;
}(import12.AppView));
exports.View_SelectWithObject0 = View_SelectWithObject0;
var renderType_BasicSelectWithArray_Host = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, [], {});
var View_BasicSelectWithArray_Host0 = (function (_super) {
    __extends(View_BasicSelectWithArray_Host0, _super);
    function View_BasicSelectWithArray_Host0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_BasicSelectWithArray_Host0, renderType_BasicSelectWithArray_Host, import16.ViewType.HOST, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_BasicSelectWithArray_Host0.prototype.createInternal = function (rootSelector) {
        this._el_0 = import14.selectOrCreateRenderHostElement(this.renderer, 'app', import14.EMPTY_INLINE_ARRAY, rootSelector, null);
        this.compView_0 = new View_BasicSelectWithArray0(this.viewUtils, this, 0, this._el_0);
        this._BasicSelectWithArray_0_3 = new Wrapper_BasicSelectWithArray();
        this.compView_0.create(this._BasicSelectWithArray_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [this._el_0]), null);
        return new import18.ComponentRef_(0, this, this._el_0, this._BasicSelectWithArray_0_3.context);
    };
    View_BasicSelectWithArray_Host0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import1.BasicSelectWithArray) && (0 === requestNodeIndex))) {
            return this._BasicSelectWithArray_0_3.context;
        }
        return notFoundResult;
    };
    View_BasicSelectWithArray_Host0.prototype.detectChangesInternal = function (throwOnChange) {
        this._BasicSelectWithArray_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_BasicSelectWithArray_Host0.prototype.destroyInternal = function () {
        this.compView_0.destroy();
    };
    View_BasicSelectWithArray_Host0.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    return View_BasicSelectWithArray_Host0;
}(import12.AppView));
exports.BasicSelectWithArrayNgFactory = new import18.ComponentFactory('app', View_BasicSelectWithArray_Host0, import1.BasicSelectWithArray);
var styles_BasicSelectWithArray = [];
var renderType_BasicSelectWithArray = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, styles_BasicSelectWithArray, {});
var View_BasicSelectWithArray0 = (function (_super) {
    __extends(View_BasicSelectWithArray0, _super);
    function View_BasicSelectWithArray0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_BasicSelectWithArray0, renderType_BasicSelectWithArray, import16.ViewType.COMPONENT, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_BasicSelectWithArray0.prototype.createInternal = function (rootSelector) {
        var parentRenderNode = this.renderer.createViewRoot(this.parentElement);
        this._text_0 = this.renderer.createText(parentRenderNode, '\n        ', null);
        this._el_1 = import14.createRenderElement(this.renderer, parentRenderNode, 'ng2-select', import14.EMPTY_INLINE_ARRAY, null);
        this.compView_1 = new import20.View_Ng2Select0(this.viewUtils, this, 1, this._el_1);
        this._Ng2Select_1_3 = new import20.Wrapper_Ng2Select();
        this._NG_VALUE_ACCESSOR_1_4 = [this._Ng2Select_1_3.context];
        this._NgModel_1_5 = new import21.Wrapper_NgModel(null, null, null, this._NG_VALUE_ACCESSOR_1_4);
        this._NgControl_1_6 = this._NgModel_1_5.context;
        this._NgControlStatus_1_7 = new import22.Wrapper_NgControlStatus(this._NgControl_1_6);
        this._text_2 = this.renderer.createText(null, '\n        ', null);
        this.compView_1.create(this._Ng2Select_1_3.context);
        this._text_3 = this.renderer.createText(parentRenderNode, '\n    ', null);
        var disposable_0 = import14.subscribeToRenderElement(this, this._el_1, new import14.InlineArray2(2, 'ngModelChange', null), this.eventHandler(this.handleEvent_1));
        this._NgModel_1_5.subscribe(this, this.eventHandler(this.handleEvent_1), true);
        this.init(null, (this.renderer.directRenderer ? null : [
            this._text_0,
            this._el_1,
            this._text_2,
            this._text_3
        ]), [disposable_0]);
        return null;
    };
    View_BasicSelectWithArray0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import19.Ng2Select) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._Ng2Select_1_3.context;
        }
        if (((token === import23.NG_VALUE_ACCESSOR) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NG_VALUE_ACCESSOR_1_4;
        }
        if (((token === import24.NgModel) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgModel_1_5.context;
        }
        if (((token === import25.NgControl) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControl_1_6;
        }
        if (((token === import26.NgControlStatus) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControlStatus_1_7.context;
        }
        return notFoundResult;
    };
    View_BasicSelectWithArray0.prototype.detectChangesInternal = function (throwOnChange) {
        var currVal_1_0_0 = 'Please choose Language';
        this._Ng2Select_1_3.check_placeholder(currVal_1_0_0, throwOnChange, false);
        var currVal_1_0_1 = this.context.options;
        this._Ng2Select_1_3.check_options(currVal_1_0_1, throwOnChange, false);
        this._Ng2Select_1_3.ngDoCheck(this, this._el_1, throwOnChange);
        var currVal_1_1_0 = this.context.language;
        this._NgModel_1_5.check_model(currVal_1_1_0, throwOnChange, false);
        this._NgModel_1_5.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.checkHost(this, this.compView_1, this._el_1, throwOnChange);
        this.compView_1.internalDetectChanges(throwOnChange);
    };
    View_BasicSelectWithArray0.prototype.destroyInternal = function () {
        this.compView_1.destroy();
        this._Ng2Select_1_3.ngOnDestroy();
        this._NgModel_1_5.ngOnDestroy();
    };
    View_BasicSelectWithArray0.prototype.handleEvent_1 = function (eventName, $event) {
        this.markPathToRootAsCheckOnce();
        var result = true;
        if ((eventName == 'ngModelChange')) {
            var pd_sub_0 = ((this.context.language = $event) !== false);
            result = (pd_sub_0 && result);
        }
        return result;
    };
    return View_BasicSelectWithArray0;
}(import12.AppView));
exports.View_BasicSelectWithArray0 = View_BasicSelectWithArray0;
var renderType_SelectWithIdentifyBy_Host = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, [], {});
var View_SelectWithIdentifyBy_Host0 = (function (_super) {
    __extends(View_SelectWithIdentifyBy_Host0, _super);
    function View_SelectWithIdentifyBy_Host0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithIdentifyBy_Host0, renderType_SelectWithIdentifyBy_Host, import16.ViewType.HOST, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithIdentifyBy_Host0.prototype.createInternal = function (rootSelector) {
        this._el_0 = import14.selectOrCreateRenderHostElement(this.renderer, 'app', import14.EMPTY_INLINE_ARRAY, rootSelector, null);
        this.compView_0 = new View_SelectWithIdentifyBy0(this.viewUtils, this, 0, this._el_0);
        this._SelectWithIdentifyBy_0_3 = new Wrapper_SelectWithIdentifyBy();
        this.compView_0.create(this._SelectWithIdentifyBy_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [this._el_0]), null);
        return new import18.ComponentRef_(0, this, this._el_0, this._SelectWithIdentifyBy_0_3.context);
    };
    View_SelectWithIdentifyBy_Host0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import1.SelectWithIdentifyBy) && (0 === requestNodeIndex))) {
            return this._SelectWithIdentifyBy_0_3.context;
        }
        return notFoundResult;
    };
    View_SelectWithIdentifyBy_Host0.prototype.detectChangesInternal = function (throwOnChange) {
        this._SelectWithIdentifyBy_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_SelectWithIdentifyBy_Host0.prototype.destroyInternal = function () {
        this.compView_0.destroy();
    };
    View_SelectWithIdentifyBy_Host0.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    return View_SelectWithIdentifyBy_Host0;
}(import12.AppView));
exports.SelectWithIdentifyByNgFactory = new import18.ComponentFactory('app', View_SelectWithIdentifyBy_Host0, import1.SelectWithIdentifyBy);
var styles_SelectWithIdentifyBy = [];
var renderType_SelectWithIdentifyBy = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, styles_SelectWithIdentifyBy, {});
var View_SelectWithIdentifyBy0 = (function (_super) {
    __extends(View_SelectWithIdentifyBy0, _super);
    function View_SelectWithIdentifyBy0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithIdentifyBy0, renderType_SelectWithIdentifyBy, import16.ViewType.COMPONENT, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithIdentifyBy0.prototype.createInternal = function (rootSelector) {
        var parentRenderNode = this.renderer.createViewRoot(this.parentElement);
        this._text_0 = this.renderer.createText(parentRenderNode, '\n    ', null);
        this._el_1 = import14.createRenderElement(this.renderer, parentRenderNode, 'ng2-select', import14.EMPTY_INLINE_ARRAY, null);
        this.compView_1 = new import20.View_Ng2Select0(this.viewUtils, this, 1, this._el_1);
        this._Ng2Select_1_3 = new import20.Wrapper_Ng2Select();
        this._NG_VALUE_ACCESSOR_1_4 = [this._Ng2Select_1_3.context];
        this._NgModel_1_5 = new import21.Wrapper_NgModel(null, null, null, this._NG_VALUE_ACCESSOR_1_4);
        this._NgControl_1_6 = this._NgModel_1_5.context;
        this._NgControlStatus_1_7 = new import22.Wrapper_NgControlStatus(this._NgControl_1_6);
        this._text_2 = this.renderer.createText(null, '\n    ', null);
        this.compView_1.create(this._Ng2Select_1_3.context);
        this._text_3 = this.renderer.createText(parentRenderNode, '\n', null);
        var disposable_0 = import14.subscribeToRenderElement(this, this._el_1, new import14.InlineArray2(2, 'ngModelChange', null), this.eventHandler(this.handleEvent_1));
        this._NgModel_1_5.subscribe(this, this.eventHandler(this.handleEvent_1), true);
        this.init(null, (this.renderer.directRenderer ? null : [
            this._text_0,
            this._el_1,
            this._text_2,
            this._text_3
        ]), [disposable_0]);
        return null;
    };
    View_SelectWithIdentifyBy0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import19.Ng2Select) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._Ng2Select_1_3.context;
        }
        if (((token === import23.NG_VALUE_ACCESSOR) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NG_VALUE_ACCESSOR_1_4;
        }
        if (((token === import24.NgModel) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgModel_1_5.context;
        }
        if (((token === import25.NgControl) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControl_1_6;
        }
        if (((token === import26.NgControlStatus) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControlStatus_1_7.context;
        }
        return notFoundResult;
    };
    View_SelectWithIdentifyBy0.prototype.detectChangesInternal = function (throwOnChange) {
        var currVal_1_0_0 = 'Please choose Language';
        this._Ng2Select_1_3.check_placeholder(currVal_1_0_0, throwOnChange, false);
        var currVal_1_0_1 = this.context.options;
        this._Ng2Select_1_3.check_options(currVal_1_0_1, throwOnChange, false);
        var currVal_1_0_2 = 'value';
        this._Ng2Select_1_3.check_displayBy(currVal_1_0_2, throwOnChange, false);
        var currVal_1_0_3 = 'id';
        this._Ng2Select_1_3.check_identifyBy(currVal_1_0_3, throwOnChange, false);
        this._Ng2Select_1_3.ngDoCheck(this, this._el_1, throwOnChange);
        var currVal_1_1_0 = this.context.language;
        this._NgModel_1_5.check_model(currVal_1_1_0, throwOnChange, false);
        this._NgModel_1_5.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.checkHost(this, this.compView_1, this._el_1, throwOnChange);
        this.compView_1.internalDetectChanges(throwOnChange);
    };
    View_SelectWithIdentifyBy0.prototype.destroyInternal = function () {
        this.compView_1.destroy();
        this._Ng2Select_1_3.ngOnDestroy();
        this._NgModel_1_5.ngOnDestroy();
    };
    View_SelectWithIdentifyBy0.prototype.handleEvent_1 = function (eventName, $event) {
        this.markPathToRootAsCheckOnce();
        var result = true;
        if ((eventName == 'ngModelChange')) {
            var pd_sub_0 = ((this.context.language = $event) !== false);
            result = (pd_sub_0 && result);
        }
        return result;
    };
    return View_SelectWithIdentifyBy0;
}(import12.AppView));
exports.View_SelectWithIdentifyBy0 = View_SelectWithIdentifyBy0;
var renderType_SelectWithMultipleSelection_Host = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, [], {});
var View_SelectWithMultipleSelection_Host0 = (function (_super) {
    __extends(View_SelectWithMultipleSelection_Host0, _super);
    function View_SelectWithMultipleSelection_Host0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithMultipleSelection_Host0, renderType_SelectWithMultipleSelection_Host, import16.ViewType.HOST, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithMultipleSelection_Host0.prototype.createInternal = function (rootSelector) {
        this._el_0 = import14.selectOrCreateRenderHostElement(this.renderer, 'app', import14.EMPTY_INLINE_ARRAY, rootSelector, null);
        this.compView_0 = new View_SelectWithMultipleSelection0(this.viewUtils, this, 0, this._el_0);
        this._SelectWithMultipleSelection_0_3 = new Wrapper_SelectWithMultipleSelection();
        this.compView_0.create(this._SelectWithMultipleSelection_0_3.context);
        this.init(this._el_0, (this.renderer.directRenderer ? null : [this._el_0]), null);
        return new import18.ComponentRef_(0, this, this._el_0, this._SelectWithMultipleSelection_0_3.context);
    };
    View_SelectWithMultipleSelection_Host0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import1.SelectWithMultipleSelection) && (0 === requestNodeIndex))) {
            return this._SelectWithMultipleSelection_0_3.context;
        }
        return notFoundResult;
    };
    View_SelectWithMultipleSelection_Host0.prototype.detectChangesInternal = function (throwOnChange) {
        this._SelectWithMultipleSelection_0_3.ngDoCheck(this, this._el_0, throwOnChange);
        this.compView_0.internalDetectChanges(throwOnChange);
    };
    View_SelectWithMultipleSelection_Host0.prototype.destroyInternal = function () {
        this.compView_0.destroy();
    };
    View_SelectWithMultipleSelection_Host0.prototype.visitRootNodesInternal = function (cb, ctx) {
        cb(this._el_0, ctx);
    };
    return View_SelectWithMultipleSelection_Host0;
}(import12.AppView));
exports.SelectWithMultipleSelectionNgFactory = new import18.ComponentFactory('app', View_SelectWithMultipleSelection_Host0, import1.SelectWithMultipleSelection);
var styles_SelectWithMultipleSelection = [];
var renderType_SelectWithMultipleSelection = import14.createRenderComponentType('', 0, import15.ViewEncapsulation.None, styles_SelectWithMultipleSelection, {});
var View_SelectWithMultipleSelection0 = (function (_super) {
    __extends(View_SelectWithMultipleSelection0, _super);
    function View_SelectWithMultipleSelection0(viewUtils, parentView, parentIndex, parentElement) {
        return _super.call(this, View_SelectWithMultipleSelection0, renderType_SelectWithMultipleSelection, import16.ViewType.COMPONENT, viewUtils, parentView, parentIndex, parentElement, import17.ChangeDetectorStatus.CheckAlways) || this;
    }
    View_SelectWithMultipleSelection0.prototype.createInternal = function (rootSelector) {
        var parentRenderNode = this.renderer.createViewRoot(this.parentElement);
        this._text_0 = this.renderer.createText(parentRenderNode, '\n    ', null);
        this._el_1 = import14.createRenderElement(this.renderer, parentRenderNode, 'ng2-select', import14.EMPTY_INLINE_ARRAY, null);
        this.compView_1 = new import20.View_Ng2Select0(this.viewUtils, this, 1, this._el_1);
        this._Ng2Select_1_3 = new import20.Wrapper_Ng2Select();
        this._NG_VALUE_ACCESSOR_1_4 = [this._Ng2Select_1_3.context];
        this._NgModel_1_5 = new import21.Wrapper_NgModel(null, null, null, this._NG_VALUE_ACCESSOR_1_4);
        this._NgControl_1_6 = this._NgModel_1_5.context;
        this._NgControlStatus_1_7 = new import22.Wrapper_NgControlStatus(this._NgControl_1_6);
        this._text_2 = this.renderer.createText(null, '\n    ', null);
        this.compView_1.create(this._Ng2Select_1_3.context);
        this._text_3 = this.renderer.createText(parentRenderNode, '\n', null);
        var disposable_0 = import14.subscribeToRenderElement(this, this._el_1, new import14.InlineArray2(2, 'ngModelChange', null), this.eventHandler(this.handleEvent_1));
        this._NgModel_1_5.subscribe(this, this.eventHandler(this.handleEvent_1), true);
        this.init(null, (this.renderer.directRenderer ? null : [
            this._text_0,
            this._el_1,
            this._text_2,
            this._text_3
        ]), [disposable_0]);
        return null;
    };
    View_SelectWithMultipleSelection0.prototype.injectorGetInternal = function (token, requestNodeIndex, notFoundResult) {
        if (((token === import19.Ng2Select) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._Ng2Select_1_3.context;
        }
        if (((token === import23.NG_VALUE_ACCESSOR) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NG_VALUE_ACCESSOR_1_4;
        }
        if (((token === import24.NgModel) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgModel_1_5.context;
        }
        if (((token === import25.NgControl) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControl_1_6;
        }
        if (((token === import26.NgControlStatus) && ((1 <= requestNodeIndex) && (requestNodeIndex <= 2)))) {
            return this._NgControlStatus_1_7.context;
        }
        return notFoundResult;
    };
    View_SelectWithMultipleSelection0.prototype.detectChangesInternal = function (throwOnChange) {
        var currVal_1_0_0 = 'Please choose Language';
        this._Ng2Select_1_3.check_placeholder(currVal_1_0_0, throwOnChange, false);
        var currVal_1_0_1 = this.context.options;
        this._Ng2Select_1_3.check_options(currVal_1_0_1, throwOnChange, false);
        var currVal_1_0_2 = 'value';
        this._Ng2Select_1_3.check_displayBy(currVal_1_0_2, throwOnChange, false);
        var currVal_1_0_3 = 'id';
        this._Ng2Select_1_3.check_identifyBy(currVal_1_0_3, throwOnChange, false);
        var currVal_1_0_4 = true;
        this._Ng2Select_1_3.check_multiple(currVal_1_0_4, throwOnChange, false);
        this._Ng2Select_1_3.ngDoCheck(this, this._el_1, throwOnChange);
        var currVal_1_1_0 = this.context.language;
        this._NgModel_1_5.check_model(currVal_1_1_0, throwOnChange, false);
        this._NgModel_1_5.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.ngDoCheck(this, this._el_1, throwOnChange);
        this._NgControlStatus_1_7.checkHost(this, this.compView_1, this._el_1, throwOnChange);
        this.compView_1.internalDetectChanges(throwOnChange);
    };
    View_SelectWithMultipleSelection0.prototype.destroyInternal = function () {
        this.compView_1.destroy();
        this._Ng2Select_1_3.ngOnDestroy();
        this._NgModel_1_5.ngOnDestroy();
    };
    View_SelectWithMultipleSelection0.prototype.handleEvent_1 = function (eventName, $event) {
        this.markPathToRootAsCheckOnce();
        var result = true;
        if ((eventName == 'ngModelChange')) {
            var pd_sub_0 = ((this.context.language = $event) !== false);
            result = (pd_sub_0 && result);
        }
        return result;
    };
    return View_SelectWithMultipleSelection0;
}(import12.AppView));
exports.View_SelectWithMultipleSelection0 = View_SelectWithMultipleSelection0;
//# sourceMappingURL=testing-helpers.ngfactory.js.map