"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var equal = require('equals');
function Selectable() {
    return function (target) {
        var toggle = function (item) {
            var _this = this;
            if (this.multiple === false) {
                return;
            }
            if (this.isSelected(item)) {
                this.value = this.value.filter(function (value) { return !_this.isEqual(item, value); });
            }
            else {
                this.value = this.value.concat([item]);
            }
        };
        Object.assign(target.prototype, {
            toggle: toggle
        });
    };
}
exports.Selectable = Selectable;
//# sourceMappingURL=selectable.js.map